import static lib.IO.*;

public class ListMapIncomplete extends AbstractMap {
	
    private Element head;
    
    /**
     * creates a new empty list
     */
    public ListMapIncomplete() {
        this.head = null;
    }
    
    /**
     * checks whether the list is empty
     * @return true iff the list is empty
     */
    public boolean isEmpty() {
        return head == null;
    }
    
    /**
     * computes the size of the list
     * @return the size of the list
     */
    public int size() {
        if (head == null) {
            return 0;
        } else {
            return head.size();
        }
    }
    
    /**
     * returns a string-representation of this list
     * @return a string representation of this list
     */
    public String toString() {
        return this.toString(false);
    }
    
    /**
     * returns a string-representation of this list
     * @param reverse if set to true then the elements are listed in reversed order
     * @return a string representation of this list
     */
    public String toString(boolean reverse) {
        String result = "(";
        if (head != null) 
            result += head.toString(reverse);        
        return result + ")";
    }
    
    
    /**
     * inserts some data into the list
     * @param key key to be inserted
     * @param data the data to be inserted
     */
    protected void insert(String key, String data) {
        head = new Element(key, data, head);
    }
        
	public String get(String key) {
		// TODO 
	}

	public Iterator keys() {
		// TODO 
	}

	public void put(String key, String value) {
		// TODO
	}
            
}
